<script>
import { utils } from '@hperchec/scorpion-ui'
// Mixins
import Variantable from '@/mixins/variantable'
import VModelable from '@/mixins/v-modelable/'
import ExtractsCSSClasses from '@/mixins/extracts-css-classes/'

// utils
const { random, isNull } = utils

/**
 * BaseInput component
 */
export default {
  name: 'BaseInput',
  mixins: [
    Variantable,
    VModelable,
    ExtractsCSSClasses
  ],
  model: {
    // Emit also "changed" custom event on "input" emit
    mirrorEvents: [ 'changed' ] // eslint-disable-line vue/valid-model-definition
  },
  props: {
    /**
     * value (to use v-model directive)
     * See also how to [customize component v-model](https://vuejs.org/v2/guide/components-custom-events.html#Customizing-Component-v-model)
     */
    value: {
      type: String,
      default: ''
    },
    /**
     * Input name
     */
    name: {
      type: String,
      default: ''
    },
    /**
     * Input type
     * Can be any HTML input type value (see also [W3Schools documentation](https://www.w3schools.com/html/html_form_input_types.asp))
     */
    type: {
      type: String,
      default: 'text'
    },
    /**
     * Defines if required
     */
    required: {
      type: Boolean,
      default: false
    },
    /**
     * capture attribute
     * See: https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/capture
     */
    capture: {
      type: String,
      default () {
        return undefined
      }
    },
    /**
     * accept attribute
     * See: https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/accept
     */
    accept: {
      type: String,
      default () {
        return undefined
      }
    },
    /**
     * disabled
     */
    disabled: {
      type: Boolean,
      default: false
    },
    /**
     * Auto-complete option
     */
    autocomplete: {
      type: String,
      default () {
        return undefined
      }
    },
    /**
     * Label text
     */
    label: {
      type: String,
      default: ''
    },
    /**
     * Label element class
     */
    labelClass: {
      type: String,
      default: ''
    },
    /**
     * Placeholder
     */
    placeholder: {
      type: String,
      default: ''
    },
    /**
     * State
     */
    state: {
      type: Boolean,
      default: true
    },
    /**
     * Input element class
     */
    inputClass: {
      type: String,
      default: ''
    },
    /**
     * Input element ID
     */
    inputId: {
      type: String,
      default: ''
    },
    /**
     * Input element ref
     */
    inputRef: {
      type: String,
      default: function () {
        return `input_${random.alphaNumeric(10)}` // Random string of length: 10
      }
    },
    /**
     * Validated status
     */
    validatedStatus: {
      type: Boolean,
      default: null
    },
    /**
     * Description
     */
    description: {
      type: [ Boolean, String ],
      default: false
    },
    /**
     * Description element class
     */
    descriptionClass: {
      type: String,
      default: ''
    },
    /**
     * Error message
     */
    error: {
      type: String,
      default: ''
    },
    /**
     * Max length
     */
    maxlength: {
      type: Number,
      default: null
    },
    /**
     * Error element class
     */
    errorClass: {
      type: String,
      default: ''
    },
    /**
     * Defines if width = 100%
     */
    fluid: {
      type: Boolean,
      default: false
    },
    pattern: {
      type: String,
      default: null
    }
  },
  computed: {
    /**
     * showValidatedIndicator
     */
    showValidatedIndicator: function () {
      return !isNull(this.validatedStatus)
    }
  }
}
</script>

<style lang="scss">
  ._input-container {
    @apply block;
    @apply mb-4;
    overflow: auto;

    ._input-label {
      @apply flex items-center;
      @apply mb-2;
    }

    ._input {
      @apply relative;
    }

    ._input-description {
      @apply text-sm;
      @apply mb-2;
    }

    ._input-error {
      @apply @light:text-@light-error;
      @apply @dark:text-@dark-error;
      @apply text-sm;
      @apply mb-2;
    }

    ._input-radio + label {
      @apply bg-@light-secondary shadow rounded-md;
      @apply block cursor-pointer;
      @apply py-3 px-5;
    }

    ._input-radio:hover + label {
      @apply bg-@light-action border-@light-action;
    }

    ._input-radio:checked + label {
      @apply bg-@light-action border-@light-action;
    }
  }
</style>
